/*
  
  Origami Boogie Box Machine
  
  28 May 2015
  Pavel Mihaylov
  Instructables - hertzgamma
  www.maketechnics.com

*/
 
// Pin names - set correctly to arrange the matrix rows a,b,c,d and columns 1,2,3,4,5 for easy programming
int a5 = 1;
int a4 = 5;
int a3 = 9;
int a2 = 10;
int a1 = A0;

int b5 = 0;
int b4 = 4;
int b3 = 8;
int b2 = 11;
int b1 = A1;

int c5 = A5;
int c4 = 3;
int c3 = 7;
int c2 = 12;
int c1 = A2;

int d5 = A4;
int d4 = 2;
int d3 = 6;
int d2 = 13;
int d1 = A3;

int NEED_TO_INIT = 1;     //This remembers if the coils have been initialized
int DEBUG = 0;            //Will turn Test function on if 1, otherwise leave to 0
int del = 300;            //Dance beat delay
int del2 = 600;
int del_short = 50;      //Delay used in spins
int DANCE = 1;            //Dance or not?

int l_pos = b2;
int r_pos = b4;

// the setup routine runs once when you press reset:
void setup() {                
  // initialize the pins as output.
  pinMode(a1, OUTPUT);
  pinMode(a2, OUTPUT);
  pinMode(a3, OUTPUT);
  pinMode(a4, OUTPUT);
  pinMode(a5, OUTPUT);
  pinMode(b1, OUTPUT);
  pinMode(b2, OUTPUT);
  pinMode(b3, OUTPUT);
  pinMode(b4, OUTPUT);
  pinMode(b5, OUTPUT);
  pinMode(c1, OUTPUT);
  pinMode(c2, OUTPUT);
  pinMode(c3, OUTPUT);
  pinMode(c4, OUTPUT);
  pinMode(c5, OUTPUT);
  pinMode(d1, OUTPUT);
  pinMode(d2, OUTPUT);
  pinMode(d3, OUTPUT);
  pinMode(d4, OUTPUT);
  pinMode(d5, OUTPUT);
  
}

// -------------------------------- beginning LOOP ROUTINE --------------------------------
// Functions bank:
// set_left(); sets the left leg to position b2 (use only at the start)
// set_right(); sets the right leg to position b4 (use only at the start)
// L_forward(); moves left leg forward (use on rows a,b,c only)
// R_forward(); moves right leg forward (use on rows a,b,c only) 
// L_back(); moves left leg forward
// R_back(); moves right leg forward
// L_side(); moves left leg to the outside
// R_side(); moves right leg to the outside
// L_cent(); moves left leg to centre
// R_cent(); moves righ leg to centre


void loop() {

  if(NEED_TO_INIT == 1) initialise(); //Initialise all coils to be switched off
  
  if(DEBUG == 1) test(); //Test finction - set DEBUG variable to 1 to turn the test on
  else if(DANCE ==1){
    
    //Dance routine goes here
    
    
    //End of dance routine
    DANCE = 0;
  }
  
}
// -------------------------------- end of LOOP ROUTINE --------------------------------








// -------------------------------- beginning initial position set up --------------------------------

// Function will set the coil number that is passed to it ON
void set_left(char pos){
  digitalWrite(pos, HIGH);
}

void set_right(char pos){
  digitalWrite(pos, HIGH);
}
// -------------------------------- end of initial position set up --------------------------------







// -------------------------------- beginning FORWARD LEFT function --------------------------------
// Checks where the left leg is and then moves it forward
void L_forward(){

  //Turning off the previous position
  digitalWrite(l_pos, LOW);  

  //Checking where the Left leg was and setting it one step forward
  if(l_pos == a1) l_pos = b1;      // a rows go to b rows
  else if(l_pos == a2) l_pos = b2;
  else if(l_pos == a3) l_pos = b3;
  else if(l_pos == a4) l_pos = b4;
  else if(l_pos == a5) l_pos = b5;
  else if(l_pos == b1) l_pos = c1; // b rows go to c rows
  else if(l_pos == b2) l_pos = c2;
  else if(l_pos == b3) l_pos = c3;
  else if(l_pos == b4) l_pos = c4;
  else if(l_pos == b5) l_pos = c5;
  else if(l_pos == c1) l_pos = d1; // c rows go to d rows
  else if(l_pos == c2) l_pos = d2;
  else if(l_pos == c3) l_pos = d3;
  else if(l_pos == c4) l_pos = d4;
  else if(l_pos == c5) l_pos = d5;
  
  //Turning on the new position
  digitalWrite(l_pos, HIGH);  
}
// -------------------------------- end of FORWARD LEFT function --------------------------------




// -------------------------------- beginning FORWARD RIGHT function --------------------------------
// Checks where the right leg is and then moves it forward
void R_forward(){

  //Turning off the previous position
  digitalWrite(r_pos, LOW);  

  //Checking where the right leg was and setting it one step forward
  if(r_pos == a1) r_pos = b1;      // a rows go to b rows
  else if(r_pos == a2) r_pos = b2;
  else if(r_pos == a3) r_pos = b3;
  else if(r_pos == a4) r_pos = b4;
  else if(r_pos == a5) r_pos = b5;
  else if(r_pos == b1) r_pos = c1; // b rows go to c rows
  else if(r_pos == b2) r_pos = c2;
  else if(r_pos == b3) r_pos = c3;
  else if(r_pos == b4) r_pos = c4;
  else if(r_pos == b5) r_pos = c5;
  else if(r_pos == c1) r_pos = d1; // c rows go to d rows
  else if(r_pos == c2) r_pos = d2;
  else if(r_pos == c3) r_pos = d3;
  else if(r_pos == c4) r_pos = d4;
  else if(r_pos == c5) r_pos = d5;
  
  //Turning on the new position
  digitalWrite(r_pos, HIGH);  
}
// -------------------------------- end of FORWARD RIGHT function --------------------------------





// -------------------------------- beginning BACKWARD LEFT function --------------------------------
// Checks where the left leg is and then moves it backward
void L_back(){

  //Turning off the previous position
  digitalWrite(l_pos, LOW);  

  //Checking where the Left leg was and setting it one step backward
  if(l_pos == b1) l_pos = a1;     // b rows go to a rows
  else if(l_pos == b2) l_pos = a2;
  else if(l_pos == b3) l_pos = a3;
  else if(l_pos == b4) l_pos = a4;
  else if(l_pos == b5) l_pos = a5;
  else if(l_pos == c1) l_pos = b1; // c rows go to b rows
  else if(l_pos == c2) l_pos = b2;
  else if(l_pos == c3) l_pos = b3;
  else if(l_pos == c4) l_pos = b4;
  else if(l_pos == c5) l_pos = b5; 
  else if(l_pos == d1) l_pos = c1; // d rows go to c rows
  else if(l_pos == d2) l_pos = c2;
  else if(l_pos == d3) l_pos = c3;
  else if(l_pos == d4) l_pos = c4;
  else if(l_pos == d5) l_pos = c5;
  
  //Turning on the new position
  digitalWrite(l_pos, HIGH);  
}
// -------------------------------- end of BACKWARD LEFT function --------------------------------




// -------------------------------- beginning BACKWARD RIGHT function --------------------------------
// Checks where the right leg is and then moves it backward
void R_back(){

  //Turning off the previous position
  digitalWrite(r_pos, LOW);  

  //Checking where the Left leg was and setting it one step backward
  if(r_pos == b1) r_pos = a1;     // b rows go to a rows
  else if(r_pos == b2) r_pos = a2;
  else if(r_pos == b3) r_pos = a3;
  else if(r_pos == b4) r_pos = a4;
  else if(r_pos == b5) r_pos = a5;
  else if(r_pos == c1) r_pos = b1; // c rows go to b rows
  else if(r_pos == c2) r_pos = b2;
  else if(r_pos == c3) r_pos = b3;
  else if(r_pos == c4) r_pos = b4;
  else if(r_pos == c5) r_pos = b5; 
  else if(r_pos == d1) r_pos = c1; // d rows go to c rows
  else if(r_pos == d2) r_pos = c2;
  else if(r_pos == d3) r_pos = c3;
  else if(r_pos == d4) r_pos = c4;
  else if(r_pos == d5) r_pos = c5;
  
  //Turning on the new position
  digitalWrite(r_pos, HIGH);  
}
// -------------------------------- end of BACKWARD RIGHT function --------------------------------





// -------------------------------- beginning SIDEWAYS RIGHT function --------------------------------
// Checks where right leg is and then moves it towards the outside
void R_side(){

  //Turning off the previous position
  digitalWrite(r_pos, LOW);  

  //Checking where the right leg was and setting it one step forward
  if(r_pos == a1) r_pos = a2;      // a(n) rows go to a(n+1) rows
  else if(r_pos == a2) r_pos = a3;
  else if(r_pos == a3) r_pos = a4;
  else if(r_pos == a4) r_pos = a5;
  else if(r_pos == b1) r_pos = b2;      // b(n) rows go to b(n+1) rows
  else if(r_pos == b2) r_pos = b3;
  else if(r_pos == b3) r_pos = b4;
  else if(r_pos == b4) r_pos = b5;
  else if(r_pos == c1) r_pos = c2;      // c(n) rows go to c(n+1) rows
  else if(r_pos == c2) r_pos = c3;
  else if(r_pos == c3) r_pos = c4;
  else if(r_pos == c4) r_pos = c5;
  else if(r_pos == d1) r_pos = d2;      // d(n) rows go to d(n+1) rows
  else if(r_pos == d2) r_pos = d3;
  else if(r_pos == d3) r_pos = d4;
  else if(r_pos == d4) r_pos = d5;
  
  //Turning on the new position
  digitalWrite(r_pos, HIGH);  
}
// -------------------------------- end of SIDEWAYS RIGHT function --------------------------------





// -------------------------------- beginning SIDEWAYS LEFT function --------------------------------
// Checks where the left leg is and then moves it towards the outside
void L_side(){

  //Turning off the previous position
  digitalWrite(l_pos, LOW);  

  //Checking where the right leg was and setting it one step forward
  if(l_pos == a5) l_pos = a4;      // a(n) rows go to a(n-1) rows
  else if(l_pos == a4) l_pos = a3;
  else if(l_pos == a3) l_pos = a2;
  else if(l_pos == a2) l_pos = a1;
  else if(l_pos == b5) l_pos = b4;      // b(n) rows go to b(n-1) rows
  else if(l_pos == b4) l_pos = b3;
  else if(l_pos == b3) l_pos = b2;
  else if(l_pos == b2) l_pos = b1;
  else if(l_pos == c5) l_pos = c4;      // c(n) rows go to c(n-1) rows
  else if(l_pos == c4) l_pos = c3;
  else if(l_pos == c3) l_pos = c2;
  else if(l_pos == c2) l_pos = c1;
  else if(l_pos == d5) l_pos = d4;      // d(n) rows go to d(n-1) rows
  else if(l_pos == d4) l_pos = d3;
  else if(l_pos == d3) l_pos = d2;
  else if(l_pos == d2) l_pos = d1;
  
  //Turning on the new position
  digitalWrite(l_pos, HIGH);  
}
// -------------------------------- end of SIDEWAYS LEFT function --------------------------------






// -------------------------------- beginning TO centre RIGHT function --------------------------------
// Checks where the right leg is and then moves it towards the centre
void R_cent(){

  //Turning off the previous position
  digitalWrite(r_pos, LOW);  

  //Checking where the right leg was and setting it one step forward
  if(r_pos == a5) r_pos = a4;      // a(n) rows go to a(n-1) rows
  else if(r_pos == a4) r_pos = a3;
  else if(r_pos == a3) r_pos = a2;
  else if(r_pos == a2) r_pos = a1;
  else if(r_pos == b5) r_pos = b4;      // b(n) rows go to b(n-1) rows
  else if(r_pos == b4) r_pos = b3;
  else if(r_pos == b3) r_pos = b2;
  else if(r_pos == b2) r_pos = b1;
  else if(r_pos == c5) r_pos = c4;      // c(n) rows go to c(n-1) rows
  else if(r_pos == c4) r_pos = c3;
  else if(r_pos == c3) r_pos = c2;
  else if(r_pos == c2) r_pos = c1;
  else if(r_pos == d5) r_pos = d4;      // d(n) rows go to d(n-1) rows
  else if(r_pos == d4) r_pos = d3;
  else if(r_pos == d3) r_pos = d2;
  else if(r_pos == d2) r_pos = d1;
  
  //Turning on the new position
  digitalWrite(r_pos, HIGH);  
}
// -------------------------------- end of TO centre RIGHT function --------------------------------




// -------------------------------- beginning TO centre LEFT function --------------------------------
// Checks where the left leg is and then moves it towards the centre
void L_cent(){

  //Turning off the previous position
  digitalWrite(l_pos, LOW);  

  //Checking where the right leg was and setting it one step forward
  if(l_pos == a1) l_pos = a2;      // a(n) rows go to a(n+1) rows
  else if(l_pos == a2) l_pos = a3;
  else if(l_pos == a3) l_pos = a4;
  else if(l_pos == a4) l_pos = a5;
  else if(l_pos == b1) l_pos = b2;      // b(n) rows go to b(n+1) rows
  else if(l_pos == b2) l_pos = b3;
  else if(l_pos == b3) l_pos = b4;
  else if(l_pos == b4) l_pos = b5;
  else if(l_pos == c1) l_pos = c2;      // c(n) rows go to c(n+1) rows
  else if(l_pos == c2) l_pos = c3;
  else if(l_pos == c3) l_pos = c4;
  else if(l_pos == c4) l_pos = c5;
  else if(l_pos == d1) l_pos = d2;      // d(n) rows go to d(n+1) rows
  else if(l_pos == d2) l_pos = d3;
  else if(l_pos == d3) l_pos = d4;
  else if(l_pos == d4) l_pos = d5;
  
  //Turning on the new position
  digitalWrite(l_pos, HIGH);  
}
// -------------------------------- end of TO centre LEFT function --------------------------------





// -------------------------------- beginning OFF ALL --------------------------------
// Will turn all coils off
void off_all(){
  initialise();
}
// -------------------------------- end of OFF ALL --------------------------------






// -------------------------------- beginning INITIALISATION --------------------------------

// Initialisation function to make  
// sure all pins are set
// to LOW in the beginning

void initialise(){
  
  digitalWrite(a1, LOW);
  digitalWrite(a2, LOW);
  digitalWrite(a3, LOW);
  digitalWrite(a4, LOW);
  digitalWrite(a5, LOW);
  
  digitalWrite(b1, LOW);
  digitalWrite(b2, LOW);
  digitalWrite(b3, LOW);
  digitalWrite(b4, LOW);
  digitalWrite(b5, LOW);
  
  digitalWrite(c1, LOW);
  digitalWrite(c2, LOW);
  digitalWrite(c3, LOW);
  digitalWrite(c4, LOW);
  digitalWrite(c5, LOW);
  
  digitalWrite(d1, LOW);
  digitalWrite(d2, LOW);
  digitalWrite(d3, LOW);
  digitalWrite(d4, LOW);
  digitalWrite(d5, LOW);
  
  NEED_TO_INIT = 0;
}
// -------------------------------- end of INITIALISATION --------------------------------






// -------------------------------- beginning COIL ON --------------------------------

// Function will set the coil number that is passed to it ON
void on(char pin){
  digitalWrite(pin, HIGH);
}

// -------------------------------- end of COIL ON --------------------------------







// -------------------------------- beginning COIL OFF --------------------------------

// Function will set the coil number that is passed to it OFF
void off(char pin){
  digitalWrite(pin, LOW);
}

// -------------------------------- end of COIL OFF --------------------------------






// -------------------------------- beginning TEST function --------------------------------
void test(){
  
  on(a5);
  delay(del);
  
  off(a5);
  on(b5);
  delay(del);

  off(b5);
  on(c5);
  delay(del);

  off(c5);
  on(d5);
  delay(del);

  off(d5);
  on(d4);
  delay(del);
  
  off(d4);
  on(c4);
  delay(del);

  off(c4);
  on(b4);
  delay(del);

  off(b4);
  on(a4);
  delay(del);

  off(a4);
  on(a3);
  delay(del);
  
  off(a3);
  on(b3);
  delay(del);

  off(b3);
  on(c3);
  delay(del);

  off(c3);
  on(d3);
  delay(del);

  off(d3);
  on(d2);
  delay(del);

  off(d2);
  on(c2);
  delay(del);

  off(c2);
  on(b2);
  delay(del);

  off(b2);
  on(a2);
  delay(del);

  off(a2);
  on(a1);
  delay(del);

  off(a1);
  on(b1);
  delay(del);

  off(b1);
  on(c1);
  delay(del);

  off(c1);
  on(d1);
  delay(del);

  off(d1);
  on(c2);
  delay(del);

  off(c2);
  on(b3);
  delay(del);

  off(b3);
  on(a4);
  delay(del);

  off(a4);

}
// -------------------------------- end of TEST function --------------------------------
